Index: trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90	(revision 2292)
+++ trunk/LMDZ.TITAN/libf/phytitan/calc_ysat.F90	(revision 2326)
@@ -10,6 +10,7 @@
   !     S. Lebonnois 
   !     -> inicondens.F in old Titan, with T,P in planetary average
-  !     J. Vatant d'Ollone (2017)
-  !     -> Adapt to new physics, move to F90 and compute every grid point 
+  !     J. Vatant d'Ollone
+  !       -> 2017 : Adapt to new physics, move to F90 and compute every grid point 
+  !       -> 2018 : Update saturation profiles from recent litterature ( Vuitton 2019 ) 
   !     ==============================================================================
 
@@ -62,14 +63,16 @@
      else if(trim(cnames(ic)).eq."C2H2") then
 
-        ysat(:,:,ic) = 10.0**(6.09748e0-1644.1e0/temp(:,:)+7.42346e0                        &
-             * alog10(1.0e3/temp(:,:)) ) / press(:,:)*1013.25e0/760.0
+!        ysat(:,:,ic) = 10.0**(6.09748e0-1644.1e0/temp(:,:)+7.42346e0                        &
+!             * alog10(1.0e3/temp(:,:)) ) / press(:,:)*1013.25e0/760.0
+
+         ysat(:,:,ic) = 1.E5 * exp(13.4-2536./temp(:,:)) / press(:,:) ! Fray and Schmidt (2009)
 
      else if(trim(cnames(ic)).eq."C2H4") then
 
-        where (temp(:,:).lt.89.0)
+        where (temp(:,:).lt.89.0) ! not far from Fray and Schmidt, 2009
            ysat(:,:,ic) = 10.0**(1.5477e0 + (1.0e0/temp(:,:) - 0.011e0)                     &
                 * (16537.0e0*(1.0e0/temp(:,:) - 0.011e0) - 1038.1e0))                       &
                 / press(:,:) * 1.01325e0 / 760.0
-        elsewhere (temp(:,:).lt.104.0)
+        elsewhere (temp(:,:).lt.104.0) ! not far from Fray and Schmidt, 2009
            ysat(:,:,ic) = 10.0**(8.724e0 - 901.6e0/(temp(:,:) - 2.555e0) )                  &
                 / press(:,:) * 1013.25e0 / 760.0
@@ -85,6 +88,9 @@
 
         where (temp(:,:).lt.90.)
-           ysat(:,:,ic) = 10.0**(10.01e0-1085.0e0/(temp(:,:)-0.561e0) )                     &
-                / press(:,:) * 1013.25e0 / 760.0e0
+!           ysat(:,:,ic) = 10.0**(10.01e0-1085.0e0/(temp(:,:)-0.561e0) )                     &
+!                / press(:,:) * 1013.25e0 / 760.0e0
+           ysat(:,:,ic) = 1.E5 * exp ( 15.11 - 2207./temp(:,:) - 24110./(temp(:,:)**2)       &
+                        + 7.744E5/(temp(:,:)**3) - 1.161E7/(temp(:,:)**4)                    &
+                        + 6.763E7/(temp(:,:)**5) ) / press(:,:) ! Fray and Schmidt (2009)
         elsewhere
            ysat(:,:,ic) = 10.0**(5.9366e0 - 1086.17e0/temp(:,:) + 3.83464e0                 &
@@ -135,11 +141,16 @@
      else if(trim(cnames(ic)).eq."AC6H6")  then
 
-        x = 1.0e0 - temp(:,:) / 562.2e0
-        ysat(:,:,ic)= 48.9e3 * exp( ( 1.33213 * x**1.5 - 6.98273 * x                        &
-             - x**3 * (2.62863 + 3.33399 * x**3) ) * 562.2e0/temp(:,:) ) / press(:,:)
+        !x = 1.0e0 - temp(:,:) / 562.2e0
+        !ysat(:,:,ic)= 48.9e3 * exp( ( 1.33213 * x**1.5 - 6.98273 * x                        &
+        !     - x**3 * (2.62863 + 3.33399 * x**3) ) * 562.2e0/temp(:,:) ) / press(:,:)
 
+        ysat(:,:,ic) = 1.E5 * exp (17.35-5663./temp(:,:)) / press(:,:) ! Fray and Schmidt (2009)
+        
      else if(trim(cnames(ic)).eq."HCN")  then
 
-        ysat(:,:,ic)= 10.0**(8.6165e0 - 1516.5e0/(temp(:,:) - 26.2e0) ) / press(:,:) * 1013.25e0 / 760.0e0
+        !ysat(:,:,ic)= 10.0**(8.6165e0 - 1516.5e0/(temp(:,:) - 26.2e0) ) / press(:,:) * 1013.25e0 / 760.0e0
+        
+        ysat(:,:,ic) = 1.E5 * exp ( 13.93 - 3624./temp(:,:) - 1.325E5/(temp(:,:)**2)       &
+                     + 6.314E6/(temp(:,:)**3) - 1.128E8/(temp(:,:)**4) ) / press(:,:)  ! Fray and Schmidt (2009)
 
      else if(trim(cnames(ic)).eq."CH3CN")  then
Index: trunk/LMDZ.TITAN/libf/phytitan/calchim.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/calchim.F90	(revision 2292)
+++ trunk/LMDZ.TITAN/libf/phytitan/calchim.F90	(revision 2326)
@@ -165,5 +165,9 @@
      PRINT*, 'CHIMIE, premier appel'
 
-     call check(nlaykim_tot,klev-15,nlrt_kim,nkim)
+     if (ngrid .eq. 1) then ! if 1D no dynamic mixing, we set the kedd in all column
+       call check(nlaykim_tot,0,nlrt_kim,nkim)
+     else
+       call check(nlaykim_tot,klev-15,nlrt_kim,nkim)
+     endif
 
      ALLOCATE(r1d(131))
Index: trunk/LMDZ.TITAN/libf/phytitan/chem_settings.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/chem_settings.F90	(revision 2292)
+++ trunk/LMDZ.TITAN/libf/phytitan/chem_settings.F90	(revision 2326)
@@ -13,5 +13,5 @@
 !           file but not composition fields. The presence of the
 !           1st field is tested and then we assume there's either
-!           no one or all of the 44 chemistry scheme species.
+!           no one or all of the nkim chemistry scheme species.
 !
 ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -97,6 +97,6 @@
                
     ! Load others fields if first one found only as we assume we can't do uncomplete chemistry
-    ! NB : We assume a given order of the 44 chemistry species !!
-    ! ( H=1, H2=2 ..., C4N2=44) -> cf comchem_h
+    ! NB : We assume a given order of the chemistry species !!
+    ! ( H=1, H2=2 ...,) -> cf comchem_h
     
     DO iq=2,nkim
Index: trunk/LMDZ.TITAN/libf/phytitan/comchem_h.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/comchem_h.F90	(revision 2292)
+++ trunk/LMDZ.TITAN/libf/phytitan/comchem_h.F90	(revision 2326)
@@ -31,5 +31,5 @@
 
    !! Hard-coded number of chemical species for Titan chemistry
-   INTEGER, PARAMETER :: nkim = 44
+   INTEGER, PARAMETER :: nkim = 43
 
    !! Hard-coded chemical species for Titan chemistry
@@ -38,9 +38,9 @@
        "CH4       ", "C2        ", "C2H       ", "C2H2      ", "C2H3      ", "C2H4      ", &
        "C2H5      ", "C2H6      ", "C3H3      ", "C3H5      ", "C3H6      ", "C3H7      ", & 
-       "C4H       ", "C4H3      ", "C4H4      ", "C4H2s     ", "CH2CCH2   ", "CH3CCH    ", &
-       "C3H8      ", "C4H2      ", "C4H6      ", "C4H10     ", "AC6H6     ", "C3H2      ", &
-       "C4H5      ", "AC6H5     ", "N2        ", "N4S       ", "CN        ", "HCN       ", &
-       "H2CN      ", "CHCN      ", "CH2CN     ", "CH3CN     ", "C3N       ", "HC3N      ", &
-       "NCCN      ", "C4N2      "/)
+       "C4H       ", "C4H3      ", "C4H4      ", "CH2CCH2   ", "CH3CCH    ", "C3H8      ", &
+       "C4H2      ", "C4H6      ", "C4H10     ", "AC6H6     ", "C3H2      ", "C4H5      ", &
+       "AC6H5     ", "N2        ", "N4S       ", "CN        ", "HCN       ", "H2CN      ", &
+       "CHCN      ", "CH2CN     ", "CH3CN     ", "C3N       ", "HC3N      ", "NCCN      ", &
+       "C4N2      "/)
    !! Hard-coded chemical species for Titan chemistry + "HV" specie for the photochem module.
    CHARACTER(len=10), DIMENSION(nkim+1)  :: nomqy_c ! Initialized in calchim with null terminator
@@ -48,7 +48,7 @@
    REAL, DIMENSION(nkim), PARAMETER               :: cmmol = (/ &
        1.01   , 2.0158, 13.02, 14.03, 14.03, 15.03, 16.04  , 24.02, 25.03, 26.04  , 27.05  , &
-       28.05  , 29.06 , 30.07, 39.06, 41.07, 42.08, 43.09  , 49.05, 51.07, 52.08  , 50.06  , &
-       40.07  , 40.07 , 44.11, 50.06, 54.09, 58.13, 78.1136, 38.05, 53.07, 77.1136, 28.0134, &
-       14.01  , 26.02 , 27.04, 28.05, 39.05, 40.04, 41.05  , 50.04, 51.05, 52.04  , 76.1   /)
+       28.05  , 29.06 , 30.07, 39.06, 41.07, 42.08, 43.09  , 49.05, 51.07, 52.08  , 40.07  , &
+       40.07 , 44.11, 50.06, 54.09, 58.13, 78.1136, 38.05, 53.07, 77.1136, 28.0134, 14.01  , &
+       26.02 , 27.04, 28.05, 39.05, 40.04, 41.05  , 50.04, 51.05, 52.04  , 76.1   /)
 
    !! Hard-coded molar fraction of surface methane
@@ -86,6 +86,6 @@
    
    ! These 3 parameters as well as nkim above, MUST match titan.h in chimtitan !!
-   INTEGER, PARAMETER :: nd_kim   = 54     ! Number of photodissociations
-   INTEGER, PARAMETER :: nr_kim   = 377    ! Number of reactions in chemistry scheme
+   INTEGER, PARAMETER :: nd_kim   = 55     ! Number of photodissociations
+   INTEGER, PARAMETER :: nr_kim   = 330    ! Number of reactions in chemistry scheme
    INTEGER, PARAMETER :: nlrt_kim = 650    ! For the UV rad. transf., 650 levels of 2 km
 