Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/abort_gcm.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/abort_gcm.F	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/abort_gcm.F	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/abort_gcm.F
+link ../../../../LMDZ.COMMON/libf/dyn3d/abort_gcm.F
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comconst_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comconst_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comconst_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comconst_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comconst_mod.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comgeom.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comgeom.h	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comgeom.h	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comgeom.h
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comgeom.h
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comvert_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comvert_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/comvert_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/comvert_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/comvert_mod.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/control_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/control_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/control_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/control_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/control_mod.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/disvert.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/disvert.F	(revision 2365)
+++ 	(revision )
@@ -1,1 +1,0 @@
-link ../../dyn3d/disvert.F
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/disvert_noterre.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/disvert_noterre.F	(revision 2366)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/disvert_noterre.F	(revision 2366)
@@ -0,0 +1,1 @@
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/disvert_noterre.F
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/ener_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/ener_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/ener_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/ener_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/ener_mod.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/infotrac.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/infotrac.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/infotrac.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/infotrac.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/infotrac.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/logic_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/logic_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/logic_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/logic_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d/logic_mod.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/mod_const_mpi.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/mod_const_mpi.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/mod_const_mpi.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/mod_const_mpi.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d/mod_const_mpi.F90
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/paramet.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/paramet.h	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/paramet.h	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/paramet.h
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/paramet.h
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/rcm1d.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/rcm1d.F	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/rcm1d.F	(revision 2366)
@@ -28,5 +28,5 @@
      &                       presnivs,pseudoalt,scaleheight
       USE vertical_layers_mod, ONLY: init_vertical_layers
-      USE logic_mod, ONLY: hybrid,autozlevs
+      USE logic_mod, ONLY: hybrid
       use regular_lonlat_mod, only: init_regular_lonlat
       use planete_mod, only: ini_planete_mod
@@ -35,4 +35,5 @@
       use mod_interface_dyn_phys, only: init_interface_dyn_phys
       use inifis_mod, only: inifis
+      use phys_state_var_mod, only: phys_state_var_init
       use physiq_mod, only: physiq
       implicit none
@@ -118,4 +119,5 @@
 
 !     added by RW for autozlevs computation
+      logical autozlevs
       real nu, xx, pMIN, zlev, Htop
       real logplevs(llm)
@@ -132,23 +134,20 @@
 c INITIALISATION
 c=======================================================================
-! initialize "serial/parallel" related stuff
-!      CALL init_phys_lmdz(iim,jjm+1,llm,1,(/(jjm-1)*iim+2/))
-!      CALL init_phys_lmdz(1,1,llm,1,(/1/))
-!      call initcomgeomphy
-
-      !! those are defined in surfdat_h.F90
-      IF (.not. ALLOCATED(albedodat)) ALLOCATE(albedodat(1))
-      IF (.not. ALLOCATED(phisfi)) ALLOCATE(phisfi(1))
-      IF (.not. ALLOCATED(zmea)) ALLOCATE(zmea(1))
-      IF (.not. ALLOCATED(zstd)) ALLOCATE(zstd(1))
-      IF (.not. ALLOCATED(zsig)) ALLOCATE(zsig(1))
-      IF (.not. ALLOCATED(zgam)) ALLOCATE(zgam(1))
-      IF (.not. ALLOCATED(zthe)) ALLOCATE(zthe(1))
-      !! those are defined in comdiurn_h.F90
-      IF (.not.ALLOCATED(sinlat)) ALLOCATE(sinlat(1))
-      IF (.not.ALLOCATED(coslat)) ALLOCATE(coslat(1))
-      IF (.not.ALLOCATED(sinlon)) ALLOCATE(sinlon(1))
-      IF (.not.ALLOCATED(coslon)) ALLOCATE(coslon(1))
-
+
+      ! read nq from traceur.def
+      open(90,file='traceur.def',status='old',form='formatted',
+     &       iostat=ierr)
+      if (ierr.eq.0) then
+        read(90,*,iostat=ierr) nq
+      else
+        nq=0
+      endif
+      close(90)
+      
+      ! Initialize dimphy module
+      call init_dimphy(1,llm) 
+      ! now initialize arrays using phys_state_var_init
+      call phys_state_var_init(nq)
+      
       saveprofile=.false.
       saveprofile=.true.
@@ -480,5 +479,5 @@
 !      call init_vertical_layers(nlayer,preff,scaleheight,
 !     &                      ap,bp,aps,bps,presnivs,pseudoalt)
-      call init_dimphy(1,nlayer) ! Initialize dimphy module
+!      call init_dimphy(1,nlayer) ! Initialize dimphy module
       call ini_planete_mod(nlayer,preff,ap,bp)
 
@@ -643,5 +642,5 @@
       endif
 
-      call disvert
+      call disvert_noterre
       ! now that disvert has been called, initialize module vertical_layers_mod
       call init_vertical_layers(nlayer,preff,scaleheight,
@@ -669,4 +668,6 @@
          ENDDO
          
+
+
          DO ilayer=1,nlayer
 !     zlay(ilayer)=-300.E+0 *r*log(play(ilayer)/plev(1))
Index: trunk/LMDZ.TITAN/libf/phytitan/dyn1d/serre_mod.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/dyn1d/serre_mod.F90	(revision 2365)
+++ trunk/LMDZ.TITAN/libf/phytitan/dyn1d/serre_mod.F90	(revision 2366)
@@ -1,1 +1,1 @@
-link ../../dyn3d/serre_mod.F90
+link ../../../../LMDZ.COMMON/libf/dyn3d_common/serre_mod.F90