Index: trunk/LMDZ.GENERIC/README
===================================================================
--- trunk/LMDZ.GENERIC/README	(revision 2354)
+++ trunk/LMDZ.GENERIC/README	(revision 2403)
@@ -1587,2 +1587,7 @@
 Major cleanup: remove obsolete compilation scripts (makegcm*) and old dynamical
 core, as it is obsolete with respect to the one provide in LMDZ.COMMON.
+
+
+== 09/07/2020 == DB
+Add kstar parameter to control kmin value (set value in the parameterization). kmin=1/lambda_max, to ensure the "subgrid scale" characteristic, we have to constrain the maximum GW's wavelength (lambda_max) by the size of the mesh. So, kmin=max(kstar, kmin prescribed value) 
+
Index: trunk/LMDZ.GENERIC/deftank/def_generic_giants/PROTO_Saturn_Article/z2sig.def
===================================================================
--- trunk/LMDZ.GENERIC/deftank/def_generic_giants/PROTO_Saturn_Article/z2sig.def	(revision 2354)
+++ trunk/LMDZ.GENERIC/deftank/def_generic_giants/PROTO_Saturn_Article/z2sig.def	(revision 2403)
@@ -19,45 +19,80 @@
 179.0
 191.0
-203.0
-215.0
-227.0
-239.0
+201.0
+211.0
+221.0
+231.0
+241.0
 251.0
-263.0
+259.0
+267.0
 275.0
-287.0
+283.0
+291.0
 299.0
-311.0
-323.0
-335.0
-347.0
-359.0
-371.0
-383.0
-395.0
-407.0
-419.0
-431.0
-443.0
-455.0
-467.0
-479.0
-491.0
-503.0
-515.0
-527.0
-539.0
-551.0
-563.0
-575.0
-587.0
-599.0
-611.0
-623.0
-635.0
-647.0
-659.0
-671.0
-683.0
+307.0
+313.0
+319.0
+325.0
+331.0
+337.0
+343.0
+349.0
+355.0
+361.0
+367.0
+373.0
+379.0
+385.0
+391.0
+397.0
+403.0
+409.0
+415.0
+421.0
+427.0
+433.0
+439.0
+445.0
+451.0
+457.0
+463.0
+469.0
+475.0
+481.0
+487.0
+493.0
+499.0
+505.0
+511.0
+517.0
+523.0
+529.0
+535.0
+541.0
+547.0
+553.0
+559.0
+571.0
+577.0
+583.0
+589.0
+595.0
+601.0
+607.0
+613.0
+619.0
+625.0
+631.0
+637.0
+643.0
+649.0
+655.0
+661.0
+667.0
+673.0
+679.0
+685.0
+691.0
 695.0
 707.0
Index: trunk/LMDZ.GENERIC/deftank/saturn1d/profile
===================================================================
--- trunk/LMDZ.GENERIC/deftank/saturn1d/profile	(revision 2354)
+++ trunk/LMDZ.GENERIC/deftank/saturn1d/profile	(revision 2403)
@@ -64,2 +64,38 @@
 130
 130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
+130
Index: trunk/LMDZ.GENERIC/libf/phystd/nonoro_gwd_ran_mod.F90
===================================================================
--- trunk/LMDZ.GENERIC/libf/phystd/nonoro_gwd_ran_mod.F90	(revision 2354)
+++ trunk/LMDZ.GENERIC/libf/phystd/nonoro_gwd_ran_mod.F90	(revision 2403)
@@ -49,4 +49,5 @@
                               gwd_convective_source
      use inifis_mod
+     use geometry_mod, only: cell_area
 #ifdef CPP_XIOS
      use xios_output_mod, only: send_xios_field
@@ -97,8 +98,11 @@
      INTEGER, parameter:: nw = nk * np *no ! Total numbers of gravity waves
      INTEGER jk, jp, jo, jw
-     REAL, parameter:: kmax = 7.e-4 ! Max horizontal wavenumber
-     REAL, parameter:: kmin = 2.e-5 ! Min horizontal wavenumber
-     !REAL, parameter:: cmax = 30.   ! Max horizontal absolute phase velocity
-     REAL, parameter:: cmax = 100.  ! Test for Saturn: Max horizontal absolute phase velocity
+     REAL kstar                  ! Control value to constrain the min horizontal wavenumber by the horizontal resolution
+     REAL, parameter:: kmax = 1.e-4 ! Max horizontal wavenumber=N/u, u(=30) zonal wind velocity at launch
+     !REAL, parameter:: kmax = 4.e-5 ! Max horizontal wavenumber=N/u, u(=70) zonal wind velocity at launch
+     REAL, parameter:: kmin = 2.e-6 ! Min horizontal wavenumber=1/sqrt(DxDy) Dx and Dy horizontal grid 
+     REAL, parameter:: cmax = 30.   ! Max horizontal absolute phase velocity=zonal wind at launch
+     !REAL, parameter:: cmax = 100.  ! Test for Saturn: Max horizontal absolute phase velocity
+     !REAL, parameter:: cmax = 70.   ! Test for Saturn: Max horizontal absolute phase velocity
      REAL, parameter:: cmin = 1.    ! Min horizontal absolute phase velocity
      REAL cpha                      ! absolute phase velocity frequency 
@@ -117,6 +121,6 @@
      REAL epflux_0(nw, ngrid)             ! Fluxes at launching level (previous name: RUW0)
      INTEGER launch                       ! Launching altitude
-     REAL, parameter:: xlaunch = 0.4      ! Control the launching altitude
-     REAL, parameter:: zmaxth_top = 8000. ! Top of convective layer (approx.)
+     REAL, parameter:: xlaunch = 0.2      ! Control the launching altitude
+     REAL, parameter:: zmaxth_top = 8000. ! Top of convective layer in m (approx.)
 
      REAL prec(ngrid)     ! precipitations
@@ -131,6 +135,9 @@
      REAL H0bis(ngrid, nlayer)       ! characteristic height of the atmosphere
      REAL, save::  H0                ! characteristic height of the atmosphere
-     REAL, parameter:: pr = 250      ! Reference pressure [Pa]
-     REAL, parameter:: tr = 220.     ! Reference temperature [K]
+     !REAL, parameter:: pr = 250      ! Reference pressure [Pa]
+     !REAL, parameter:: tr = 220.     ! Reference temperature [K]
+     ! TEST FOR SATURN STRATOSPHERE
+     REAL, parameter:: pr = 110      ! Reference pressure [Pa]
+     REAL, parameter:: tr = 130.     ! Reference temperature [K]
      REAL zh(ngrid, nlayer + 1)      ! Log-pressure altitude (constant H0) 
      REAL zhbis(ngrid, nlayer + 1)   ! Log-pressure altitude (varying H)
@@ -237,5 +244,12 @@
                         + 1.) * pi / 2.
            ! horizontal wavenumber amplitude
-           zk(jw, ii) = kmin + (kmax - kmin) * ran_num_2
+           ! TN+GG April/June 2020
+           ! "Individual waves are not supposed
+           ! to occupy the entire domain, but
+           ! only a faction of it" Lott+2012
+
+           !zk(jw, ii) = kmin + (kmax - kmin) * ran_num_2
+           kstar = pi / sqrt(cell_area(ii))
+           zk(jw, ii) = max(kmin,kstar) + (kmax - max(kmin,kstar)) * ran_num_2
            ! horizontal phase speed
            cpha = 0. 